local drawobjects = {}


function drawobjects.DrawAgents()

	for k,v in pairs(Agents) do
		
		local x = v.body:getX()
		local y = v.body:getY()
	
		if k == 1 then
			love.graphics.setColor(1,0,1,1)
		else
			love.graphics.setColor(1,1,1,1)
		end
		love.graphics.circle("fill", x,y, gintAgentRadius )	

		love.graphics.print(cf.round(v.age,0), x + 10, y - 10)
		
		
		if k == 1 then
			-- love.graphics.setColor(0,1,1,1)
			-- love.graphics.print(cf.round(v.output1,4), 5,40)
			-- love.graphics.print(cf.round(v.output2,4), 75,40)
			-- love.graphics.print(cf.round(v.output3,4), 150,40)
			-- love.graphics.print(cf.round(v.output4,4), 225,40)
		end	
		
		
	end


end

function drawobjects.DrawWorld()

	local drawingx = gintLeftBorder
	local drawingy = gintTopBorder
	local drawingwidth = gintBorderWidth
	local drawingheight = gintBorderHeight
	
	local centrex = gintScreenWidth / 2
	local centrey = gintScreenHeight / 2	
	
	love.graphics.setColor(1,1,1,1)
	love.graphics.rectangle("line", gintLeftBorder,gintTopBorder,drawingwidth,drawingheight)
	
	love.graphics.line(centrex - 25,centrey, centrex + 25, centrey)
	love.graphics.line(centrex, centrey -25, centrex,centrey + 25)

	-- highscore
	--love.graphics.print(cf.round(gintHighScore,0), 5,5)
	
	-- parent 1
	--local mystring = garrParent1[1] .. " " .. garrParent1[2] .. " " .. garrParent1[3]  .. " " .. garrParent1[4] .. " " ..  garrParent1[5] .. " " ..  garrParent1[6] .. " " ..  garrParent1[7] .. " " ..  garrParent1[8] .. " " ..  garrParent1[9] .. " " ..  garrParent1[10] .. " " ..  garrParent1[11] .. " " ..  garrParent1[12] .. " " ..  garrParent1[13] .. " " ..  garrParent1[14] .. " " ..  garrParent1[15] .. " : " .. cf.round(garrParent1[16],0)
	
	
	local mystring = ""
	for k,v in ipairs(garrParent1) do
		mystring = mystring .. cf.round(v,1) .. " "
	end
	love.graphics.print(mystring, 5, 15)
	
	-- parent 2
	local mystring = ""
	for k,v in ipairs(garrParent2) do
		mystring = mystring .. cf.round(v,1) .. " "
	end
	love.graphics.print(mystring, 5, 28)	
	
	

end

return drawobjects